import { watch as o, onMounted as m, ref as c, unref as y, watchEffect as g, onUpdated as p, reactive as W, toRef as S, getCurrentInstance as I, onUnmounted as P, nextTick as T, onActivated as C, readonly as R } from "vue";
import { deepMerge as E, getSlotsProps as f, isFunction as O } from "@gx-design-vue/pro-utils";
function q(e, t, n) {
  o(t, (i, a) => {
    n ? n(i, a) && e() : e();
  }), m(() => {
    e();
  });
}
const h = (typeof window > "u" ? !1 : /iPad|iPhone|iPod/.test(navigator.platform) || navigator.platform === "MacIntel" && navigator.maxTouchPoints > 1) && !window.MSStream;
function N() {
  return h;
}
const Q = typeof window > "u" ? !1 : h || window.safari !== void 0;
function U() {
  return Q;
}
const s = {
  xs: {
    maxWidth: 575,
    matchMedia: "(max-width: 575px)"
  },
  sm: {
    minWidth: 576,
    maxWidth: 767,
    matchMedia: "(min-width: 576px) and (max-width: 767px)"
  },
  md: {
    minWidth: 768,
    maxWidth: 991,
    matchMedia: "(min-width: 768px) and (max-width: 991px)"
  },
  lg: {
    minWidth: 992,
    maxWidth: 1199,
    matchMedia: "(min-width: 992px) and (max-width: 1199px)"
  },
  xl: {
    minWidth: 1200,
    maxWidth: 1599,
    matchMedia: "(min-width: 1200px) and (max-width: 1599px)"
  },
  xxl: {
    minWidth: 1600,
    matchMedia: "(min-width: 1600px)"
  }
}, F = () => {
  let e = "md";
  return typeof window > "u" || (e = Object.keys(s).find((n) => {
    const { matchMedia: i } = s[n];
    return !!window.matchMedia(i).matches;
  })), e;
}, z = () => {
  const e = c(F());
  return Object.keys(s).forEach((t) => {
    const { matchMedia: n } = s[t], i = window.matchMedia(n);
    i.matches && (e.value = t), i.onchange = (a) => {
      a.matches && (e.value = t);
    };
  }), e;
};
function B(e, t, n) {
  const i = c(e());
  return o(t, (a, u) => {
    n ? n(a, u) && (i.value = e()) : i.value = e();
  }), i;
}
function b(e) {
  const t = typeof e == "function" ? e() : e, n = c(t);
  function i(a) {
    n.value = a;
  }
  return [n, i];
}
function D(e, t) {
  const { defaultValue: n, value: i = c() } = t || {};
  let a = typeof e == "function" ? e() : e;
  i.value !== void 0 && (a = y(i)), n !== void 0 && (a = typeof n == "function" ? n() : n);
  const u = c(a), d = c(a), [l, w] = b([d.value]);
  g(() => {
    let r = i.value !== void 0 ? i.value : u.value;
    t != null && t.postState && (r = t.postState(r, u.value)), d.value = r;
  }), o(l, () => {
    var v;
    const r = l.value[0];
    u.value !== r && ((v = t == null ? void 0 : t.onChange) == null || v.call(t, u.value, r));
  }, { deep: !0 });
  function x(r) {
    u.value = r;
  }
  function M(r) {
    x(r), w([d.value]);
  }
  return o(i, () => {
    u.value = i.value;
  }), [d, M, u];
}
function G(e, t) {
  const n = c(e[t]);
  return p(() => {
    const i = e[t];
    n.value !== i && (n.value = i);
  }), n;
}
function H(e) {
  const t = typeof e == "function" ? e() : e, n = W({
    data: t
  });
  function i(a) {
    n.data = E(n.data, a);
  }
  return [S(n, "data"), i];
}
function J(e, t, n, i) {
  const a = c(f(e, t, n, i));
  return o(e.map((u) => () => n[u]), () => {
    a.value = f(e, t, n, i);
  }, { deep: 1 }), o(() => t, () => {
    a.value = f(e, t, n, i);
  }, { deep: 1 }), a;
}
function j(e) {
  I() && P(e);
}
function L(e, t, n = !1) {
  if (!O(e))
    throw new Error("handle is not Function!");
  const { readyRef: i, stop: a, start: u } = A(t);
  return n ? e() : o(i, (d) => {
    d && e();
  }, { immediate: !1 }), { readyRef: i, stop: a, start: u };
}
function A(e) {
  const t = c(!1);
  let n;
  function i() {
    t.value = !1, n && window.clearTimeout(n);
  }
  function a() {
    i(), n = setTimeout(() => {
      t.value = !0;
    }, e);
  }
  return a(), j(i), { readyRef: t, stop: i, start: a };
}
function V(e) {
  let t;
  m(() => {
    e(!1), T(() => {
      t = !0;
    });
  }), C(() => {
    t && e(!0);
  });
}
function X() {
  const e = c(!1);
  return m(() => {
    e.value = !0;
  }), R(e);
}
export {
  V as onMountedOrActivated,
  j as tryOnUnmounted,
  q as useEffect,
  N as useIsIos,
  X as useIsMounted,
  U as useIsSafari,
  z as useMediaQuery,
  B as useMemo,
  D as useMergedState,
  G as usePickSlots,
  H as useReactiveState,
  J as useSlotsProps,
  b as useState,
  L as useTimeout
};
